SuperStrict
?MacOS
Framework chaos.cocoaext
?
Import brl.Timer
Import BRL.GLMax2D
Import brl.PNGLoader
?Win32
Import Brl.RAMStream
?


Global GetNameFromHour:String[13]
GetNameFromHour[0] = "Zwlf"
GetNameFromHour[1] = "Eins"
GetNameFromHour[2] = "Zwei"
GetNameFromHour[3] = "Drei"
GetNameFromHour[4] = "Vier"
GetNameFromHour[5] = "Fnf"
GetNameFromHour[6] = "Sechs"
GetNameFromHour[7] = "Sieben"
GetNameFromHour[8] = "Acht"
GetNameFromHour[9] = "Neun"
GetNameFromHour[10] = "Zehn"
GetNameFromHour[11] = "Elf"
GetNameFromHour[12] = "Zwlf"


Global Feld:Int[13,12]
Global OldTime:Int,Time:Int[2]
Const MENU_ABOUT:Int = 1001

AppTitle = "WortUhr"


?MacOS
Local window:TGadget					=	CreateWindow(AppTitle,0,0,400,400,Null,WINDOW_TITLEBAR|WINDOW_CLIENTCOORDS|WINDOW_CENTER)

Local MyAppMenu:TGadget				=	GetCocoaApplicationMenu ()
CreateCocoaMenu ("ber {AppName}", MENU_ABOUT, MyAppMenu,0,0)

SetCocoaGadgetText (GetCocoaApplicationMenuHide (), "{AppName} ausblenden")
SetCocoaGadgetText (GetCocoaApplicationMenuHideOthers (), "Andere ausblenden")
SetCocoaGadgetText (GetCocoaApplicationMenuShowAll (), "Alle einblenden")
SetCocoaGadgetText (GetCocoaApplicationMenuQuit (), "{AppName} beenden")

Local canvas:TGadget=CreateCanvas(0,0,400,400,Window)
ActivateGadget(canvas)

SetGadgetAlpha canvas,0.8
Local Path:String = AppFile[0..AppFile.Find(".app")+4]+"/Contents/Resources/clock.png"
Local Clock:TImage = LoadImage(Path)
SetGraphics CanvasGraphics(Canvas)
?Win
Incbin "clock.png"
Local Clock:TImage = LoadImage("incbin::clock.png")
Graphics 400,400,0
?


SetBlend ALPHABLEND

Feld = CreateField(CreateTimeString())

CreateTimer(60)
While WaitEvent()
	
	Select EventID()
		Case EVENT_TIMERTICK
			If OldTime+(1000*(60-Time[2]))<MilliSecs() Then 
				ResetField()
				Feld = CreateField(CreateTimeString())
			EndIf 
			RedrawGadget canvas
		Case EVENT_GADGETPAINT
					Cls			
					ConvertToImage(Feld)
					DrawImage Clock,0,0	
					Flip 
		Case EVENT_WINDOWCLOSE, EVENT_APPTERMINATE
			?MacOS
			FreeGadget canvas
			?
			End
		?MacOS
		Case EVENT_MENUACTION
			Select EventData()
				Case MENU_ABOUT
					CocoaNotify("Programmiert am 04.09.2009 von Fabrice Weinberg"+Chr(10)+"Nach der Idee von http://store.biegertfunk.com",False, window, "OK", "ber die WortUhr")
			End Select		
		?
		End Select
Wend



Function ConvertToImage(Feld:Int[,])
	For Local x:Int = 0 To 12
		For Local Y:Int = 0 To 11
			If Feld[x,y] = 1 And X<11 And Y<10 Then 
				DrawRect X*36+11,Y*36+24,20,30
				'DrawText X+" "+Y,X*36+11,Y*36+24
			EndIf 
			If Feld[x,y] = 1 And X>10 And Y>9 Then 
				DrawRect (X-11)*381+6,(Y-10)*381+6,7,7
			EndIf 
		Next
	Next
End Function

Function CreateField:Int[,](Satz:String)
Local Wort:String[] = Satz.ToUpper().Trim().Split(" ")

Local Count:Int

For Local i:Int=0 To Wort.Length-1
	Select Wort[i]
	Case "ES"
		Feld[0,0] = 1 
		Feld[1,0] = 1
	Case "IST"
		For Count = 3 To 5
			Feld[Count,0] = 1
		Next
	?Win32
	Case "FNF"
	?MacOS
	Case "FNF"
	? 		
		If i>0 Then 
			If Wort[i-1] = "IST" Then 
				For Count = 7 To 10
					Feld[Count,0] = 1
				Next
			Else
				For Count = 0 To 3
					Feld[Count,6] = 1
				Next
			EndIf 
		Else
			For Count = 7 To 10
				Feld[Count,0] = 1
			Next
		EndIf 
	Case "ZEHN" 		
		If i>0 Then 
			If Wort[i-1] = "IST" Then 
				For Count = 0 To 3
					Feld[Count,1] = 1
				Next
			Else
				For Count = 4 To 7
					Feld[Count,8] = 1
				Next
			EndIf 
		Else
				For Count = 0 To 3
					Feld[Count,1] = 1
				Next
		EndIf 
	Case "ZWANZIG"
			For Count = 4 To 10
				Feld[Count,1] = 1
			Next
	Case "NACH"
		If i>0 Then 
			If Wort[i-1] = "VIERTEL" Then 
				For Count = 3 To 6
					Feld[Count,3] = 1
				Next
			Else
				For Count = 0 To 3
					Feld[Count,2] = 1
				Next
			EndIf 
		Else
				For Count = 7 To 10
					Feld[Count,3] = 1
				Next
		EndIf 
	Case "VIERTEL"
			For Count = 4 To 10
				Feld[Count,2] = 1
			Next
	Case "HALB"
			For Count = 7 To 10
				Feld[Count,3] = 1
			Next
	Case "VOR"
			For Count = 0 To 2 'For Count = 4 To 6
				Feld[Count,3] = 1
			Next
	Case "EINS"
		If Wort[i-1] = "IST" Then 
			For Count = 0 To 2
				Feld[Count,4] = 1
			Next
		Else
			For Count = 0 To 3
				Feld[Count,4] = 1
			Next
		EndIf 
	Case "ZWEI"
			For Count = 7 To 10
				Feld[Count,4] = 1
			Next
	Case "DREI"
			For Count = 0 To 3
				Feld[Count,5] = 1
			Next
	Case "VIER"
			For Count = 7 To 10
				Feld[Count,5] = 1
			Next
	Case "SECHS"
			For Count = 6 To 10
				Feld[Count,6] = 1
			Next
	Case "SIEBEN"
			For Count = 0 To 5
				Feld[Count,7] = 1
			Next
	Case "ACHT"
			For Count = 7 To 10
				Feld[Count,7] = 1
			Next
	Case "NEUN"
			For Count = 0 To 3
				Feld[Count,8] = 1
			Next		
	Case "ELF"
			For Count = 8 To 10
				Feld[Count,8] = 1
			Next
	?Win32
	Case "ZWLF"
	?MacOS
	Case "ZWLF"
	?
			For Count = 0 To 4
				Feld[Count,9] = 1
			Next
	Case "UHR"
			For Count = 8 To 10
				Feld[Count,9] = 1
			Next
	End Select
Next
Return Feld
End Function  




Function CreateTimeString:String()
	Local TTime:String[] = CurrentTime().Split(":")
	Local Res:String,RelTo:Int
	
	OldTime = MilliSecs()
	
	Time[0] = Int(TTime[0])
	Time[1] = Int(TTime[1])
	Time[2] = Int(TTime[2])
	
	
	Res:+"Es ist"
	
	If Time[1] = 0 Then 
		RelTo = 0 
		Res:+" "+GetNameFromHour[Time[0]-12]+ " Uhr"
	EndIf 
	If Time[1]>=30 Then 
		Time[0]:+1
		RelTo = 30
		If Time[1]=>35 Then 
			If Time[1]=>40 Then 
				If Time[1]=>45 Then 
					If Time[1]=>50 Then 
						If Time[1]=>55 Then 
							RelTo = 55 
							Res:+" fnf vor "+GetNameFromHour[Time[0]-12]
						Else
							RelTo = 50 
							Res:+" zehn vor "+GetNameFromHour[Time[0]-12]
						EndIf 
					Else
						RelTo = 45
						Res:+" viertel vor "+GetNameFromHour[Time[0]-12]
					EndIf 
				Else
					RelTo = 40
					Res:+" zwanzig vor "+GetNameFromHour[Time[0]-12]
				EndIf 
			Else
				RelTo = 35
				Res:+" fnf nach halb "+GetNameFromHour[Time[0]-12]
			EndIf 	
		Else
			Res:+" halb "+GetNameFromHour[Time[0]-12]
		EndIf 
		
	Else
		If Time[1]=>5 Then 
			If Time[1]=>10 Then 
				If Time[1]=>15 Then 
					If Time[1]=>20 Then 
						If Time[1]=>25 Then 
							RelTo = 25 
							Res:+" fnf vor halb "+GetNameFromHour[Time[0]-11]
						Else
							RelTo = 20 
							Res:+" zwanzig nach "+GetNameFromHour[Time[0]-12]
						EndIf 
					Else
						RelTo = 15
						Res:+" viertel nach "+GetNameFromHour[Time[0]-12]
					EndIf 
				Else
				RelTo = 10
				Res:+" zehn nach "+GetNameFromHour[Time[0]-12]
				EndIf 
			Else
				RelTo = 5 
				Res:+" fnf nach "+GetNameFromHour[Time[0]-12]
			EndIf 	
		Else
			RelTo = 0 
			Res:+" "+GetNameFromHour[Time[0]-12]+ " Uhr"
		EndIf 
	EndIf 
	ShowMinute(RelTo)	
	Return Res
End Function 

Function ResetField()
	For Local x:Int = 0 To 12
		For Local Y:Int = 0 To 11
			Feld[x,y] = 0 
		Next
	Next
End Function 

Function ShowMinute(RelTo:Int)
		Select Time[1]-RelTo
		Case 0
		Case 1
			Feld[11,10] = 1
		Case 2
			Feld[11,10] = 1
			Feld[12,10] = 1
		Case 3
			Feld[11,10] = 1
			Feld[12,10] = 1 
			Feld[12,11] = 1
		Default 
			Feld[11,10] = 1
			Feld[12,10] = 1 
			Feld[11,11] = 1
			Feld[12,11] = 1
		End Select 
End Function 


